
def hash_from_dict(dictionary):

    from karabo.bound import Hash

    def ensure_it_is_hashable(var):
        ''' 
        a function that recursivly makes a dictionart into a hash,
        '''
        if (not isinstance(var, dict)):
            return var
        
        # var must be dict:
        #make dict into a Hash
        
        result = Hash()
        
        for key, value in var.items():
            result.set(key, ensure_it_is_hashable(value)) 
        
        return result
    
    result = Hash()
    
    if (not isinstance(dictionary, dict)):
        print("ERROR in make_dict_to_hash, provided variable 'dictionary' is not a dictionary")
        result.set('var', dictionary)
        return result
    
    for key, value in dictionary.items():
        result.set(key, ensure_it_is_hashable(value)) 
    return result
    

def dict_from_hash(hash):
    pass